#include<bits/stdc++.h>
#define maxk 1000005
using namespace std;

int n,k;
int br[maxk]={0};
int minx[maxk]={-1},miny[maxk]={-1},maxx[maxk]={-1},maxy[maxk]={-1};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    cin>>n>>k;
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
        {
            int x;
            cin>>x;
            br[x]++;
            minx[x]=min(i,minx[x]);
            maxx[x]=max(i,maxx[x]);
            miny[x]=min(j,miny[x]);
            maxy[x]=max(j,maxy[x]);
        }
        
    int sol=0;
    for(int i=1;i<=k;i++)
    {
        if(maxx[i]==-1)continue;
        if(maxx[i]-minx[i]>1 && maxy[i]-miny[i]>1)continue;
        if((maxx[i]-minx[i]+1)*(maxy[i]-miny[i]+1)==br[i])sol++;
    }
    
    cout<<sol<<endl;
    return 0;
}